#include "iostm8l051f3.h"

long int counter = 0; //    

void delay( void ) //  
{
  for ( int i = 0; i < 500; i++ );
}
void write( long int n ) //   
{
  const char mask[10] = //   
  {
    0x5F, //0
    0x50, //1
    0x6D, //2
    0x79, //3
    0x72, //4
    0x3B, //5
    0x3F, //6
    0x53, //7
    0x7F, //8
    0x7B  //9
  };
  char dispdata[9] = {0,0,0,0,0,0,0,0,0}; //     
  for ( int i = 8; i >= 0; i--) //   
  {
    dispdata[i] = mask[n%10]; //       
    n = (long int)n/10;	//      10
    if ( n == 0 ) break; //   0,  
  }
  for ( int i = 0; i < 9; i++ ) //      
  {
      PB_ODR_bit.ODR2 =  dispdata[i] & 0x01; //       DIN
      PB_ODR_bit.ODR3 = 1; // DCLK -    
      delay(); //
      PB_ODR_bit.ODR3 = 0; // DCLK     
      PB_ODR_bit.ODR2 =  (dispdata[i] & 0x02)>>1; 
      PB_ODR_bit.ODR3 = 1;
      delay();
      PB_ODR_bit.ODR3 = 0;
      PB_ODR_bit.ODR2 =  (dispdata[i] & 0x04)>>2; 
      PB_ODR_bit.ODR3 = 1;
      delay();
      PB_ODR_bit.ODR3 = 0;
      PB_ODR_bit.ODR2 =  (dispdata[i] & 0x08)>>3; 
      PB_ODR_bit.ODR3 = 1;
      delay();
      PB_ODR_bit.ODR3 = 0;
      PB_ODR_bit.ODR2 =  (dispdata[i] & 0x10)>>4; 
      PB_ODR_bit.ODR3 = 1;
      delay();
      PB_ODR_bit.ODR3 = 0;
      PB_ODR_bit.ODR2 =  (dispdata[i] & 0x20)>>5; 
      PB_ODR_bit.ODR3 = 1;
      delay();
      PB_ODR_bit.ODR3 = 0;
      PB_ODR_bit.ODR2 =  (dispdata[i] & 0x40)>>6; 
      PB_ODR_bit.ODR3 = 1;
      delay();
      PB_ODR_bit.ODR3 = 0;
      PB_ODR_bit.ODR2 =  (dispdata[i] & 0x80)>>7; 
      PB_ODR_bit.ODR3 = 1;
      delay();
      PB_ODR_bit.ODR3 = 0;
  }
  PB_ODR_bit.ODR1 = 1; //  LOAD
  delay(); //,    
  PB_ODR_bit.ODR1 = 0; //  LOAD
}


#pragma vector = TIM2_OVR_UIF_vector //  
__interrupt void TIM2_interrupt( void )
{
  TIM2_CR1_bit.CEN = 0;  //    
  ITC_SPR3_bit.VECT9SPR = 0; 
  write( counter ); //   
  counter = 0; // 
  TIM2_CR1_bit.CEN = 1;  //  
  ITC_SPR3_bit.VECT9SPR = 1;
  TIM2_SR1_bit.UIF = 0; //  
  PB_ODR_bit.ODR0 ^= 1; //   
}

#pragma vector=EXTI7_vector //  
__interrupt void Pin1_interrupt(void) 
{
  counter++;  //   
  EXTI_SR1_bit.P7F = 1; //  ,    
}
int main( void )
{
  CLK_CKDIVR = 1; //    2
  CLK_SWCR_bit.SWEN = 1; //   
  CLK_SWR = 0x04;
  while ( CLK_SWCR_bit.SWBSY );
  CLK_CCOR_bit.CCOSEL = 0x02; // CCO  LCLK    
  while ( CLK_CCOR_bit.CCOSWBSY );
  CLK_CCOR_bit.CCODIV = 0x06; // 64
  PC_DDR_bit.DDR4 = 1;  //     
  PC_CR1_bit.C14 = 1;
  PB_DDR = 0x0F;
  PB_CR1 = 0x0F;
  write( 0 ); //   "0"
  

  PB_ODR_bit.ODR0 = 1; // 
  
  
  PB_DDR_bit.DDR7 = 0; //      
  PB_CR1_bit.C17 = 1;
  PB_CR2_bit.C27 = 1;
  EXTI_CR2_bit.P7IS = 2;
  ITC_SPR4_bit.VECT15SPR = 1;
  
  asm( "RIM" );
  CLK_PCKENR1_bit.PCKEN10 = 1; //   2
  TIM2_PSCR = 0x07; //  128
  TIM2_ARRH = 0xB7; //  1 
  TIM2_ARRL = 0x1B;

  TIM2_CR1_bit.URS = 1; //    
  TIM2_EGR_bit.UG = 1;  // Update Event

  TIM2_IER_bit.UIE = 1; // 
  TIM2_CR1_bit.CEN = 1; // 
  ITC_SPR5_bit.VECT19SPR = 3;
  asm( "WFI" ); //     
  return 0;
}
